package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;

public class Challenge extends ASN1Encodable {
   private AlgorithmIdentifier owf;
   private ASN1OctetString witness;
   private ASN1OctetString challenge;

   private Challenge(ASN1Sequence seq) {
      byte var2 = 0;
      if (seq.size() == 3) {
         byte var10002 = var2;
         var2 = 1;
         this.owf = AlgorithmIdentifier.getInstance(seq.getObjectAt(var10002));
      }

      Challenge var10000 = this;
      Challenge var4 = this;
      int var3 = var2 + 1;
      var4.witness = ASN1OctetString.getInstance(seq.getObjectAt(var2));
      var10000.challenge = ASN1OctetString.getInstance(seq.getObjectAt(var3));
   }

   public static Challenge getInstance(Object o) {
      if (o instanceof Challenge) {
         return (Challenge)o;
      } else if (o instanceof ASN1Sequence) {
         return new Challenge((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   private void addOptional(ASN1EncodableVector v, ASN1Encodable obj) {
      if (obj != null) {
         v.add(obj);
      }

   }

   public AlgorithmIdentifier getOwf() {
      return this.owf;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      this.addOptional(var1, this.owf);
      var1.add(this.witness);
      var10000.add(this.challenge);
      return new DERSequence(var1);
   }
}
